Bug 1054405 - oo-admin-yum-validator fails when provision a OSE 2.0 host with only MongoDB or ActiveMQ components.
Summary: oo-admin-yum-validator fails when provision a OSE 2.0 host with only MongoDB ...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: oc
Version: 2.0.0
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
: ---
Assignee: Brenton Leanhardt
QA Contact: libra bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-01-16 18:42 UTC by Ricardo Martinelli de Oliveira
Modified: 2018-12-04 17:00 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-05-21 20:30:37 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Ricardo Martinelli de Oliveira 2014-01-16 18:42:58 UTC
Description of problem:
Suppose customer is provisioning an OpenShift environment with the hosts containing the following components:
* One host with Broker and named
* One host with MongoDB and ActiveMQ
* One host with Node

And it is using openshift.sh bash script. There is a problem when running the script on the host that should install the MongoDB and ActiveMQ components. Below is the last part of the output:

+ '[' 0 -ne 0 ']'
+ roles=
+ need_infra_repo
+ :
+ roles=' --role broker'
+ need_client_tools_repo
+ false
+ need_node_repo
+ false
+ need_jbosseap_cartridge_repo
+ false
+ oo-admin-yum-validator -o 2.0 --fix-all --role broker
Please note: --role=broker implicitly enables --role=client to ensure /usr/bin/rhc is available for testing and troubleshooting.
Detected OpenShift Enterprise repository subscription managed by RHN Classic or RHN Satellite.

The required OpenShift Enterprise repositories are missing:
    rhel-x86_64-server-6-ose-2.0-rhc
Please verify that an OpenShift Enterprise subscription is attached to this system using either RHN Classic or Red Hat Subscription Manager by following the instructions here: https://access.redhat.com/site/articles/522923
Checking if yum-plugin-priorities is installed
Checking channel/repository priorities
Resolving repository/channel/subscription priority conflicts
Setting priority for repository rhel-x86_64-server-6-ose-2.0-infrastructure to 10
Setting priority for repository rhel-x86_64-server-6-rhscl-1 to 10
Setting priority for repository rhel-x86_64-server-6 to 20
Setting package exclusions for the following repositories:
    rhel-x86_64-server-6: tomcat6*
+ oo-admin-yum-validator -o 2.0 --role broker
Please note: --role=broker implicitly enables --role=client to ensure /usr/bin/rhc is available for testing and troubleshooting.
Detected OpenShift Enterprise repository subscription managed by RHN Classic or RHN Satellite.

The required OpenShift Enterprise repositories are missing:
    rhel-x86_64-server-6-ose-2.0-rhc
Please verify that an OpenShift Enterprise subscription is attached to this system using either RHN Classic or Red Hat Subscription Manager by following the instructions here: https://access.redhat.com/site/articles/522923
Please re-run this tool after making any recommended repairs to this system
+ abort_install
+ [[ x == x ]]
+ echo 'OpenShift: Aborting Installation.'
OpenShift: Aborting Installation.
+ exit 1

A proposed workaround is manually set the repo and set CONF_INSTALL_METHOD="none"


Version-Release number of selected component (if applicable):
Not applicable

How reproducible:
In situations where the environment will be provisioned the way it is described in Description of the Problem section

Steps to Reproduce:
1. install RHEL 6
2. wget the openshift.sh script
3. edit openshift script to install only 

Actual results:
oo-admin-yum-validator fails to set rhel-x86_64-server-6-ose-2.0-rhc
repo

Expected results:
Install MongoDB and ActiveMQ, properly configured to use in the OpenShift Enterprise 2.0 envionment.

Additional info:

Comment 2 Brenton Leanhardt 2014-01-16 21:26:11 UTC
I wonder if something is preventing the rhn-channel from working.  As mentioned in the linked kbase article does "rhn-channel -a -c rhel-x86_64-server-6-ose-2.0-rhc" solve the problem?

Comment 3 Brenton Leanhardt 2014-01-16 21:36:10 UTC
I can definitely reproduce this.

Comment 4 Brenton Leanhardt 2014-01-16 21:45:41 UTC
Actually, talking with John.  This is probably openshift.sh failing to add the rhel-x86_64-server-6-ose-2.0-rhc channel.  We decided that anytime "oo-admin-yum-validator -o 2.0 --role broker" is called that we would also add the rhc channel.  We need to make sure openshift.sh does the same.

Comment 5 Brenton Leanhardt 2014-01-16 21:51:41 UTC
Mind trying out openshift.sh from https://github.com/openshift/openshift-extras/pull/269 ?

Comment 6 Ludovic Meurillon 2014-01-17 09:43:11 UTC
Don't you think it could be possible to add some parameters possibilities to oo-admin-yum-validator ? 

like :

oo-admin-yum-validator -o 2.0 --role msgserver
oo-admin-yum-validator -o 2.0 --role dbserver

In my case, I installed a MsgServer and a DbServer without need to add the rhel-x86_64-server-6-ose-2.0-rhc channel. ActiveMq and MongoDb don't need rhc.

I think the original could be located around : https://github.com/brenton/openshift-extras/blob/2f08a335820e8826417f162f51004be9b84eeb99/enterprise/install-scripts/generic/openshift.sh#L764 

When you need infra rhn channel (like need_infra_repo check it), it does not mean that you are on a broker host (msgserver and dbserver need infra channels to be confiured).

(In reply to Brenton Leanhardt from comment #4)
> Actually, talking with John.  This is probably openshift.sh failing to add
> the rhel-x86_64-server-6-ose-2.0-rhc channel.  We decided that anytime
> "oo-admin-yum-validator -o 2.0 --role broker" is called that we would also
> add the rhc channel.  We need to make sure openshift.sh does the same.

Comment 7 Brenton Leanhardt 2014-01-17 13:37:36 UTC
We will certainly consider improving oo-admin-yum-validator and your suggestion certainly makes sense.  If the current workaround is works for you please let us know.  Then we can clone this bug and record the feature request.

Comment 12 Luke Meyer 2014-01-22 15:24:40 UTC
Just as an aside... we should perhaps reconsider the coupling of client and broker in yum-validator for the next major release. It doesn't really make sense.


Note You need to log in before you can comment on or make changes to this bug.